var c4 = document.getElementById("animationCanvas");
var ctx4 = c4.getContext("2d");

var zIncrement = 4;
var animateSuperBallRunning = false;
var lizardTimer;
var marshTimer;
var starAnimation;

switch(gameType){
	case "game0":
		starAnimation = "starsSpriteSheet";
		break;
	case "game1":
		starAnimation = "leavesSpriteSheet";
		break;
	default:
		starAnimation = "starsSpriteSheet";
		break;
}

function fadeOutEffect(fadeTarget, flashCount, flashTotal, interval){
	if (!fadeTarget.style.opacity) {
		fadeTarget.style.opacity = 1;
	}
	var doFadeOut1 = setInterval(function () {
		if (fadeTarget.style.opacity > 0) {
			fadeTarget.style.opacity -= 0.1;
		}else{
			clearInterval(doFadeOut1);
			if(flashTotal !== -1){
				fadeInEffect(fadeTarget, flashCount, flashTotal, interval);
			}else{
				fadeTarget.style.display = 'none';
			}
		}
	}, interval);
}

function fadeInEffect(fadeTarget, flashCount, flashTotal, interval){
	fadeTarget.style.display = 'block';
	if (!fadeTarget.style.opacity) {
		fadeTarget.style.opacity = 0.01;
	}
	var fadeNumber = fadeTarget.style.opacity;
	var doFadeIn1 = setInterval(function () {
		if (fadeTarget.style.opacity < 1) {
			fadeNumber = parseFloat(fadeNumber) + parseFloat('0.1');
			fadeTarget.style.opacity = fadeNumber;
		}else{
			clearInterval(doFadeIn1);
			if(flashCount < flashTotal && flashTotal !== -1){
				fadeOutEffect(fadeTarget, flashCount + 1, flashTotal, interval);
			}
		}
	}, interval);
}

function changeColorEffect(fadeTarget, flashMax, flashCount, interval){
		var fading = true;
		var doFadeOut = setInterval(function () {
			if (!fadeTarget.style.opacity) {
				fadeTarget.style.opacity = 1;
			}
			if(fading){
				if (fadeTarget.style.opacity > 0) {
					fadeTarget.style.opacity -= 0.1;
				}else{
					fading = false;
					clearInterval(doFadeOut);
					if(flashMax !== 0){
						changeColorEffect2(fadeTarget, flashMax, flashCount, interval);
					}
				}
			}
		}, interval);

	}

	function changeColorEffect(flashMax, flashCount, interval){
		var fading = true;
		//var fadeNumber = fadeTarget.style.opacity;
		var changeColor = setInterval(function () {
			var greenOffset = (timerColor[1] * timeScale) - 20;
			greenOffset += 80 * (timeScale);

			var redOffset = ( 255 * (1 - timeScale)); 
			redOffset += 50 * (1 - timeScale);

			if(redOffset > 255){
				redOffset = 255;
			}
			if(greenOffset > 255){
				greenOffset = 255;
			}
			if(greenOffset < 0){
				greenOffset = 0;
			}
			if(flashCount % 2 === 0){
				document.getElementById("timer").style.background = 'rgb(' +  redOffset + ',' + greenOffset + ',0)';
			}else{
				document.getElementById("timer").style.background = 'white';
			}

			if (flashCount > flashMax) {
				document.getElementById("timer").style.background = 'rgb(' +  redOffset + ',' + greenOffset + ',0)';
				clearInterval(changeColor);
				changeTimerColor = false;
			}
			flashCount++;
		}, interval);
	}

function newLevelAnimation(){
	var fadeTarget = document.getElementById("mainGame");
	fadeOutEffect(fadeTarget, 1, 1, 60);
	//
	setTimeout(function(){
		document.getElementById("midLevelScoreboard").style.opacity = 0;
		document.getElementById("midLevelScoreboard").style.display = 'none';
	}, 600);
}

function levelCompleteAnimation(){
 	var fadeTarget = document.getElementById("midLevelScoreboard");
	
	var stars1 = animateScript(starAnimation, 360, 360, 0, 0, 350, 350, 33.3, false, true);
 	var stars2 = animateScript(starAnimation, 360, 360, 225, 0, 400, 400, 50, false, true);
 	var stars3 = animateScript(starAnimation, 360, 360, 510, 0, 350, 350, 33.3, false, true);

 	setTimeout(function(){
 		fadeInEffect(fadeTarget, -1, -1, 50);

 	}, 250);
	setTimeout(function(){
	 		//stopAnimate(temp);
	 		var stars4 = animateScript(starAnimation, 360, 360, 25, 175, 400, 400, 33.3, false, true);

	 }, 750);

 	setTimeout(function(){
 		//stopAnimate(temp);
 		var stars5 = animateScript(starAnimation, 360, 360, 475, 50, 400, 400, 33.3, false, true);

	 }, 1000);
return;
 	var animateTarget = document.getElementById("canvasBlock");//.style.transform = "scaleY("+ timeScale + ")";
 	var fadeTarget = document.getElementById("timeBox");
 	var fadeTarget2 = document.getElementById("leftSideGameBoard");
 	var fadeTarget3 = document.getElementById("rightSideGameBoard");
 	var fadeTarget4 = document.getElementById("canvasBlock");
 	var fadeTarget5 = document.getElementById("mainGame");

 	var buttons = document.getElementsByTagName("button");
 	for(var buttonIndex = 0; buttonIndex < buttons.length; buttonIndex++){
 		var button = buttons[buttonIndex];
 		if(button.id != "nextLevel"){
 			button.disabled = true;
 			button.style.cursor = "default";
 		}
 	}




 	var scaleY = 1;
 	paused = true;
 	var startFade = false;
 	var shrinkTarget = setInterval(function () {
 		if (scaleY < 99) {
 			scaleY+= (100 - scaleY )/5;  
				if(scaleY > 90 && !startFade){
					startFade = true;
					fadeOutEffect1(fadeTarget, -1, -1, 50);
					fadeOutEffect1(fadeTarget2, -1, -1, 50);
					fadeOutEffect1(fadeTarget3, -1, -1, 50);
					fadeOutEffect1(fadeTarget4, -1, -1, 50);
					setTimeout(function(){
						//fadeOutEffect1(fadeTarget5, 0, 1, 20);
					}, 400);
					setTimeout(function(){
						//document.getElementById("mainGame").classList.add("mainGameBackground");
						document.getElementById("midLevelBackgroundChange").style.opacity = 1;
						
					}, 470);
					setTimeout(function(){
						showMidLevelScoreboard();
					}, 500);
				}
			}else{
				clearInterval(shrinkTarget);
			}
			document.getElementById("canvasBlock").style.transform = 'scaleY(' + (1 - (scaleY / 100) )+ ')';
			document.getElementById("canvasBlock").style.top = scaleY * 0.5 + '%';
		}, 50);

 }

 function showMidLevelScoreboard(){
 	var stars1 = animateScript(starAnimation, 360, 360, 0, 0, 250, 250,  33.3, false, true);
 	var stars2 = animateScript(starAnimation, 360, 360, 225, 25, 300, 300,  50, false, true);
 	var stars3 = animateScript(starAnimation, 360, 360, 510, 0, 250, 250,  33.3, false, true);
 	document.getElementById("midLevelScoreboard").style.display = "block";

 	//var stars4 = animateScript(starAnimation, 360, 360, 0, 250, 250, 250,  33.3, false, true);
 	//var stars5 = animateScript(starAnimation, 360, 360, 510, 250, 250, 250,  33.3, false, true);

 	//var stars2 = animateScript("spriteSheet1", 360, 360, 50, 50, 200, 200,  33.3, false, true);


 	setTimeout(function(){
 		//stopAnimate(temp);
 		var stars4 = animateScript(starAnimation, 360, 360, 25, 175, 200, 200,  33.3, false, true);

 	}, 1500);

 	setTimeout(function(){
 		//stopAnimate(temp);
 		var stars5 = animateScript(starAnimation, 360, 360, 475, 50, 200, 200,  33.3, false, true);

 	}, 2000);

 	document.getElementById("midLevelScoreboard").style.visibility = "visible";
 	var fadeTargetMidLevel = document.getElementById("midLevelScoreboard");
 	fadeTargetMidLevel.style.opacity = 0;
 	fadeInEffect1(fadeTargetMidLevel, -1, -1, 50);

 	document.getElementById("midLevelScoreboardScore").innerHTML = "Your Score: " + score;
 	document.getElementById("midLevelScoreboardLevel").innerHTML = "Your Level: " + level;
 	document.getElementById("midLevelScoreboardChain").innerHTML = "Longest Chain: " + maxChainCount;

 	document.getElementById("midLevelScoreboardLevel").style.opacity = 0;
 	document.getElementById("midLevelScoreboardTitle").style.opacity = 0;
 	document.getElementById("midLevelScoreboardChain").style.opacity = 0;
 	document.getElementById("midLevelScoreboardScore").style.opacity = 0;

 	document.getElementById("midLevelScoreboardTitle").style.animationName = 'fadeInAnimation';
 	setTimeout(function(){
 		document.getElementById("midLevelScoreboardTitle").style.opacity = 1;
 		document.getElementById("midLevelScoreboardLevel").style.animationName = 'fadeInAnimation';

 		setTimeout(function(){
 			document.getElementById("midLevelScoreboardLevel").style.opacity = 1;
 			document.getElementById("midLevelScoreboardScore").style.animationName = 'fadeInAnimation';

 			setTimeout(function(){
 				document.getElementById("midLevelScoreboardScore").style.opacity = 1;
 				document.getElementById("midLevelScoreboardChain").style.animationName = 'fadeInAnimation';
 				setTimeout(function(){
 					document.getElementById("midLevelScoreboardChain").style.opacity = 1;
 				}, 500);
 				setTimeout(function(){
 					var fadeTargetMidLevel = document.getElementById("nextLevel");
 					fadeTargetMidLevel.style.opacity = 0;
 					fadeInEffect1(fadeTargetMidLevel, -1, -1, 50);
 				}, 1000);
 			}, 500);
 		}, 500);
 	}, 500);

 }


//we will use this variable to clear the setInterval()
function stopAnimate(tID) {
	clearInterval(tID);
	document.getElementById(tID).remove();
	
	//document.getElementById("spriteTest").style.visibility = 'hidden';

} //end of stopAnimate()

function stopAnimate1(tID) {
	cancelAnimationFrame(tID);
	document.getElementById(tID).remove();
	
	//document.getElementById("spriteTest").style.visibility = 'hidden';

} //end of stopAnimate()
function animateScript(elementId, frameWidth, frameHeight, xLocation, yLocation, width, height, interval, gameBoard, runOnce, grow, maxSize) {
	var tID; 
	var canv = document.createElement('canvas');
	if(gameBoard){
		canv.classList.add("canvas");
		canv.width = 360; 
		canv.height = 360;
		canv.style.zIndex = zIncrement;
		zIncrement++;
		document.getElementById("canvasBlock").appendChild(canv);
	}else{
		canv.classList.add("canvasAnimator");
		canv.width = 758;//document.getElementById("mainGame").getBoundingClientRect().width; 
		canv.height = 422;//document.getElementById("mainGame").getBoundingClientRect().height;
		canv.style.zIndex = 5;
		document.getElementById("animatorDiv").appendChild(canv);
	}
	
	
	var c5 = canv;//document.getElementById("animationCanvas");
	var ctx5 = c5.getContext("2d");

	canv.style.visibility = 'visible';
	var positionX = 0; //start position for the image slicer
	var positionY = 0;
	if(elementId === "ballExplosion"){
		//positionX = 3 * frameWidth;
	}
	//var interval = 33.3; //100 ms of interval for the setInterval()
	var image1 = document.getElementById(elementId);// new Image();
	var deltaTime = 0;               
	var lastUpdate = Date.now();
	var size = 0;
	//var doAnimate = function(){
		tID = setInterval (function (){
			ctx5.clearRect(0,0, c5.width, c5.height);
			spriteWidth = document.getElementById(elementId).width;
			spriteHeight = document.getElementById(elementId).height;
			if(grow && width + size < maxSize){
				size+= maxSize  / 20;//((frameWidth / spriteWidth) / (frameHeight / spriteHeight));
				ctx5.drawImage(image1, positionX, positionY, frameWidth, frameHeight, xLocation - (size / 2), yLocation - (size / 2), width + size, height + size);

			}else{
				ctx5.drawImage(image1, positionX, positionY, frameWidth, frameHeight, xLocation, yLocation, width, height);

			}
			if(elementId === "lizardSprite1"){
 				lizardTimer = tID;
			}
			if(elementId === "lizardSprite2"){
 				lizardTimer = tID;
			}
			if(elementId === 'marsh1'){
				marshTimer = tID;
			}
			if(elementId === 'marsh2'){
				marshTimer = tID;
			}
		//document.getElementById("spriteTest").style.backgroundPosition = 	`-${position}px ${positionY}px`; 
		if (positionX < spriteWidth - frameWidth){ 
			positionX = positionX + frameWidth;
		}
		else{ 
			if(positionY < spriteHeight - frameHeight){
				positionY += frameHeight;
				positionX = 0; 
			}else{
				positionY = 0;
				positionX = 0; 
				if(elementId === "ballExplosion"){
					positionX = 3 * frameWidth;
				}
			}
		}
	/*
		setTimeout(function(){
			doAnimate();
		}, interval);
		*/
		if(runOnce && positionX === 0 && positionY === 0){
			if(elementId === "lizardSprite1"){
 				lizardTimer = animateScript("lizardSprite2", frameWidth, frameHeight, xLocation, yLocation, width, height, interval, false, false);
 				setTimeout(function(){
					stopAnimate(tID);
 				}, 40);
 				return;
			}
			if(elementId === "marsh1"){
 				marshTimer = animateScript("marsh2", frameWidth, frameHeight, xLocation, yLocation, width, height, interval, false, false);
 				setTimeout(function(){
					stopAnimate(tID);
 				}, 40);
 				return;
			}
			stopAnimate(tID);
		}else{
			if(elementId === "ballExplosion"){
				if(runOnce && positionX === 3 * frameWidth && positionY === 0){
					//stopAnimate1(tID);
				}
			}
		}

	}, interval);
		canv.id = tID;
		
		return tID;

	//document.getElementById("spriteTest").style.backgroundPosition = 	`-${position}px ${positionY}px`; 


} //end of animateScript()






function loseGameAnimation(){
	mainTheme = document.getElementById("maintheme").pause();
	document.getElementById("preventInput").style.display = "none";
}




