var dragging = false;
var timer1;
var timer2;

var badClicks = 0;
var answersFound = 0;
var trackHighlight;

var answersFoundList = [];
var minimapAspectX;
var minimapAspectY;
var scoreAnimating = false;
var floatingX;
var floatingXTemp;
var floatingXTemp2;

function newRound(){
	document.getElementById("leftSideImage").src = "Assets/" + gameType + "/level" + level + "Control.png";
	document.getElementById("rightSideImage").src = "Assets/" + gameType + "/level" + level + "Changes.png";
	document.getElementById("minimapBackground").src = "Assets/" + gameType + "/level" + level + "Control.png";
	document.getElementById("minimapHighlightImage").src = "Assets/" + gameType + "/level" + level + "Control.png";
	document.getElementById('xMessageLeft').style.display = 'none';
	document.getElementById('xMessageRight').style.display = 'none';
	var event = document.createEvent("Event");
	event.initEvent("resize", false, true); 
	// args: string type, boolean bubbles, boolean cancelable
	window.dispatchEvent(event);
	//window.dispatchEvent(new Event('resize'));
	eventHandlerSetup();
	marshTimer = null;
	badClicks = 0;
	answersFound = 0
	document.getElementById('scoreboardText').innerHTML = answersFound + '/6';
	var xImages = document.getElementsByClassName('scoreboardXImage');
	for(var xIndex = 0; xIndex < xImages.length; xIndex++){
		xImages[xIndex].src = "Assets/" + gameType + "/xEmpty.png";
	}
	//answersFoundList = [];
	answersFoundList = document.getElementsByClassName("foundAnswer");
	for(var answerItem = 0; answerItem < answersFoundList.length; answerItem++){
		answersFoundList[answerItem].classList.remove("foundAnswer");

	}


	setTimeout(function(){
		minimapAspectX = document.getElementById("minimap").getBoundingClientRect().width / document.getElementById("leftSideImage").width;
		minimapAspectY = document.getElementById("minimap").getBoundingClientRect().height / document.getElementById("leftSideImage").height;
		document.getElementById('minmapHighlight').style.left = Math.abs(document.getElementById("leftSideImage").offsetLeft * minimapAspectX)  + "px";
		document.getElementById('minmapHighlight').style.top = Math.abs(document.getElementById("leftSideImage").offsetTop * minimapAspectY)  + "px";
		document.getElementById('minimapHighlightImage').style.left = (document.getElementById("leftSideImage").offsetLeft * minimapAspectX)  + "px";
		document.getElementById('minimapHighlightImage').style.top = (document.getElementById("leftSideImage").offsetTop * minimapAspectY)  + "px";
		var myNode1 = document.getElementById("imageMapLeft");
		var myNode2 = document.getElementById("imageMapRight");
		var newNode = document.getElementById("level" + level + "Map");
		while (myNode1.firstChild) {
			myNode1.removeChild(myNode1.firstChild);
			myNode2.removeChild(myNode2.firstChild);
		}
		var childList = newNode.childNodes;
		for(var child = 0; child < childList.length; child++){
			myNode1.appendChild(childList[child].cloneNode());
			myNode2.appendChild(childList[child].cloneNode());
		}
	}, 200);
}

function processAnswer(e){
	e.preventDefault();

	if(!dragging && (badClicks < 3)){
		document.getElementById("leftSideImage").ontouchend = processBadAnswer;
		document.getElementById("rightSideImage").ontouchend = processBadAnswer;
		document.getElementById("rightSideImage").focus();
		//for(var answerItem = 0; answerItem < answersFoundList.length; answerItem++){
			var stars2;
			if(e.target.classList.contains("foundAnswer")){
				switch(gameType){
					case "game0":
						stars2 = animateScript("starsSpriteSheet", 360, 360, e.clientX - 180, e.clientY - 180, 300, 300,  50, false, true);
						break;
					case "game1":
						stars2 = animateScript("leavesSpriteSheet", 360, 360, e.clientX - 180, e.clientY - 180, 300, 300,  50, false, true);
						break;
					default:
						stars2 = animateScript("starsSpriteSheet", 360, 360, e.clientX - 180, e.clientY - 180, 300, 300,  50, false, true);
						break;
				}
				if(e.touches){
					switch(gameType){
						case "game0":
							stars2 = animateScript("starsSpriteSheet", 360, 360, e.changedTouches[0].clientX - 180, e.changedTouches[0].clientY - 180, 300, 300,  50, false, true);
							break;
						case "game1":
							stars2 = animateScript("leavesSpriteSheet", 360, 360, e.changedTouches[0].clientX - 180, e.changedTouches[0].clientY - 180, 300, 300,  50, false, true);
							break;
						default:
							stars2 = animateScript("starsSpriteSheet", 360, 360, e.changedTouches[0].clientX - 180, e.changedTouches[0].clientY - 180, 300, 300,  50, false, true);
							break;
					}
				}
				return;
			}
		//}
		//console.log(e.target);
		//answersFoundList.push(e.target);
		e.target.classList.add("foundAnswer");
		answersFound++;
		document.getElementById('scoreboardText').innerHTML = answersFound + '/6';
		//document.getElementById("scoreMessage").style.animationName = 'scoreMessageAnimation';
		addScore();
		var stars2;
		switch(gameType){
			case "game0":
				stars2 = animateScript("starsSpriteSheet", 360, 360, e.clientX - 180, e.clientY - 180, 300, 300,  50, false, true);
			break;
			case "game1":
				stars2 = animateScript("leavesSpriteSheet", 360, 360, e.clientX - 180, e.clientY - 180, 300, 300,  50, false, true);
			break;
			default:
				stars2 = animateScript("starsSpriteSheet", 360, 360, e.clientX - 180, e.clientY - 180, 300, 300,  50, false, true);
			break;
		}
		if(e.touches){
			switch(gameType){
				case "game0":
					stars2 = animateScript("starsSpriteSheet", 360, 360, e.changedTouches[0].clientX - 180, e.changedTouches[0].clientY - 180, 300, 300,  50, false, true);
					break;
				case "game1":
					stars2 = animateScript("leavesSpriteSheet", 360, 360, e.changedTouches[0].clientX - 180, e.changedTouches[0].clientY - 180, 300, 300,  50, false, true);
					break;
				default:
					stars2 = animateScript("starsSpriteSheet", 360, 360, e.changedTouches[0].clientX - 180, e.changedTouches[0].clientY - 180, 300, 300,  50, false, true);
					break;
			}
		}

		if(answersFound === 6){
			if(level === 3){
				timeLeft = false;
				setTimeout(function(){
					changeScreen();
					//document.getElementById('mainMenu').style.display = 'none';
					document.getElementById('gameOverScreen').style.backgroundImage = 'url(Assets/' + gameType + '/winScreenBackground.png)';
					setTimeout(function(){
						var stars1;
						var stars2;
						var stars3;
						switch(gameType){
							case "game0":
								stars1 = animateScript("starsSpriteSheet", 360, 360, 0, 0, 350, 350, 33.3, false, true);
								stars2 = animateScript("starsSpriteSheet", 360, 360, 225, 0, 400, 400, 50, false, true);
								stars3 = animateScript("starsSpriteSheet", 360, 360, 510, 0, 350, 350, 33.3, false, true);
								setTimeout(function(){
									var marsh1 = animateScript("marsh1", 360, 360, 390, 280, 150, 150, 40, false, true);
									var lizard1 = animateScript("lizardSprite1", 360, 360, 622, 295, 140, 140, 40, false, true);
								}, 500);
								break;
							case "game1":
								stars1 = animateScript("leavesSpriteSheet", 360, 360, 0, 0, 350, 350, 33.3, false, true);
								stars2 = animateScript("leavesSpriteSheet", 360, 360, 225, 0, 400, 400, 50, false, true);
								stars3 = animateScript("leavesSpriteSheet", 360, 360, 510, 0, 350, 350, 33.3, false, true);
								break;
							default:
								stars1 = animateScript("starsSpriteSheet", 360, 360, 0, 0, 350, 350, 33.3, false, true);
								stars2 = animateScript("starsSpriteSheet", 360, 360, 225, 0, 400, 400, 50, false, true);
								stars3 = animateScript("starsSpriteSheet", 360, 360, 510, 0, 350, 350, 33.3, false, true);
								break;
						}


						setTimeout(function(){
					 		//stopAnimate(temp);
					 		var stars4;
					 		switch(gameType){
								case "game0":
									stars4 = animateScript("starsSpriteSheet", 360, 360, 25, 175, 400, 400, 33.3, false, true);
									break;
								case "game1":
									stars4 = animateScript("leavesSpriteSheet", 360, 360, 25, 175, 400, 400, 33.3, false, true);
									break;
								default:
									stars4 = animateScript("starsSpriteSheet", 360, 360, 25, 175, 400, 400, 33.3, false, true);
									break;
							}
					 	}, 750);

						setTimeout(function(){
					 		//stopAnimate(temp);
					 		var stars5;
					 		switch(gameType){
								case "game0":
									stars5 = animateScript("starsSpriteSheet", 360, 360, 475, 50, 400, 400, 33.3, false, true);
									break;
								case "game1":
									stars5 = animateScript("leavesSpriteSheet", 360, 360, 475, 50, 400, 400, 33.3, false, true);
									break;
								default:
									stars5 = animateScript("starsSpriteSheet", 360, 360, 475, 50, 400, 400, 33.3, false, true);
									break;
							}

					 	}, 1000);
					}, 500);
				}, 750);
				return;
			}
			document.getElementById('midLevelScoreboard').style.display = 'block';
			document.getElementById('midLevelBoard').src = "Assets/" + gameType + "/youBeatLevel" + level + ".png";
			setTimeout(function(){
				newLevelReached();
			}, 250);
		}
	}
}

function processBadAnswer(e){
	e.preventDefault();
	
	if(!dragging && (badClicks < 3)){
		document.getElementsByClassName('scoreboardXImage')[badClicks].src = "Assets/" + gameType + "/xRed.png";
		badClick();
		badClicks++;
		if(e.touches){
			var viewportOffset = e.target.parentElement.getBoundingClientRect();
		// these are relative to the viewport
		var xPos = e.clientX - viewportOffset.left;
		var yPos = e.clientY - viewportOffset.top;
		
		xPos = e.changedTouches[0].clientX - viewportOffset.left;
		yPos = e.changedTouches[0].clientY - viewportOffset.top;
		
		var highight;
		if(e.currentTarget.id == 'leftSideImage'){
			highight = document.getElementById('rightSideImageCircle');
		}else{
			highight = document.getElementById('leftSideImageCircle');
		}

		//highight.style.visibility = 'visible';
		highight.style.left = xPos;
		highight.style.top = yPos;
		trackHighlight = highight;
	}
	if(e.target.parentElement.id == "leftSideContainer"){
		floatingX = document.getElementById('xMessageLeft');
	}else{
		floatingX = document.getElementById('xMessageRight');
	}

	floatingX.style.display = 'block';
	floatingX.style.left = trackHighlight.offsetLeft - 15 + "px";
	if(trackHighlight.offsetTop < 40){
		floatingX.style.top = trackHighlight.offsetTop + 20 + "px";
	}else{
		floatingX.style.top = trackHighlight.offsetTop - 40 + "px";
	}

	if(scoreAnimating && floatingX === floatingXTemp){
		floatingX.style.opacity = 0;
		floatingX.style.transform = "transformY(-24px)";
		floatingX.style.scale = 1;
		floatingX.style.animationName = 'none !important';
		floatingX.style.transform = 'none !important'; 
		floatingX.style.transitionProperty = 'none !important';
		var newone = floatingX.cloneNode(true);
		floatingX.parentNode.replaceChild(newone, floatingX);
	}
	scoreAnimating = true;

	floatingX.style.animationName = 'scoreMessageAnimation';
	floatingXTemp = floatingX;
	setTimeout(function(){
		floatingX.style.animationName = 'none';
				//document.getElementById("xMessage").style.top = "30%";
				floatingX.style.display = 'none';
				scoreAnimating = false;
				document.getElementById("leftSideImage").ontouchend = processBadAnswer;
				document.getElementById("rightSideImage").ontouchend = processBadAnswer;
				document.getElementById("rightSideImage").focus();
			}, 1000);

	if(badClicks > 2){
		timeLeft = false;
		loseGameAnimation();
		setTimeout(function(){
			changeScreen();
			document.getElementById('gameOverScreen').style.backgroundImage = 'url(Assets/' + gameType + '/gameOverBackground.png)';
			marshTimer = null;
		}, 250);
	}
}
}

function eventHandlerSetup(){
	// Trigger resize event to scale image map for hot spots
	dragElement(document.getElementById("leftSideImage"));
	dragElement(document.getElementById("rightSideImage"));
	dragElement(document.getElementById("imageMapLeft"));	
	dragElement(document.getElementById("imageMapRight"));	

	document.getElementById("leftSideImage").onmouseup = processBadAnswer;
	document.getElementById("rightSideImage").onmouseup = processBadAnswer;
	document.getElementById("leftSideImage").ontouchend = processBadAnswer;
	document.getElementById("rightSideImage").ontouchend = processBadAnswer;
	document.getElementsByClassName("imageContainer")[0].onmousemove = imageHighlight;
	document.getElementsByClassName("imageContainer")[1].onmousemove = imageHighlight;
	document.getElementsByClassName("imageContainer")[0].ontouchmove = imageHighlight;
	document.getElementsByClassName("imageContainer")[1].ontouchmove = imageHighlight;

}

function imageHighlight(e){
	if(dragging){
		return;
	}
	var viewportOffset = e.currentTarget.getBoundingClientRect();
	// these are relative to the viewport
	var xPos = e.clientX - viewportOffset.left;
	var yPos = e.clientY - viewportOffset.top;
	if(e.touches){
		xPos = e.touches[0].clientX - viewportOffset.left;
		yPos = e.touches[0].clientY - viewportOffset.top;
	}
	var highight;
	if(e.currentTarget.children[0].id == 'leftSideImage'){
		highight = document.getElementById('rightSideImageCircle');
	}else{
		highight = document.getElementById('leftSideImageCircle');
	}

	highight.style.visibility = 'visible';
	highight.style.left = xPos;
	highight.style.top = yPos;
	trackHighlight = highight;

	e.target.onmouseleave = function(){
		if(dragging){
			return;
		}
		highight.style.visibility = 'hidden';
		e.target.onmouseleave = null;
	}
	e.target.ontouchend = function(e1){
		e1.preventDefault();
		highight.style.visibility = 'hidden';
		e.target.onmouseleave = null;
		dragging = false;
	}
}

function dragElement(elmnt) {
	var pos1 = 0, pos2 = 0, pos3 = 0, pos4 = 0;
	if (document.getElementById(elmnt.id)) {
    // if present, the header is where you move the DIV from:
    document.getElementById(elmnt.id).onmousedown = dragMouseDown;
    document.getElementById(elmnt.id).ontouchstart = dragMouseDown;
    //document.getElementById(elmnt.id).ontouchstart = dragMouseDown;

} else {
	    // otherwise, move the DIV from anywhere inside the DIV: 
	    elmnt.onmousedown = dragMouseDown;
	    elmnt.ontouchstart = dragMouseDown;
	}
}

function dragMouseDown(e) {
	e = e || window.event;
	e.preventDefault();

    // get the mouse cursor position at startup:
    pos3 = e.clientX;
    pos4 = e.clientY;
    if(e.touches){
    	pos3 = e.touches[0].clientX;
    	pos4 = e.touches[0].clientY;
    }
    document.onmouseup = closeDragElement;
    document.ontouchend = closeDragElement;
    //document.ontouchend = closeDragElement;
    // call a function whenever the cursor moves:
    document.onmousemove = elementDrag;
    document.ontouchmove = elementDrag;
    //document.ontouchmove = elementDrag;
}

function elementDrag(e) {
	e = e || window.event;
	e.preventDefault();
	if(e.clientX != pos3 || e.clientY != pos4){
		dragging = true;
	}
	if(e.touches){
		if(e.touches[0].clientX != pos3 || e.touches[0].clientY != pos4){
			dragging = true;
		}
	}
    // calculate the new cursor position:
    pos1 = pos3 - e.clientX;
    if(e.touches){
    	pos1 = pos3 - e.touches[0].clientX;
    }
    document.getElementById("leftSideImage").style.left = (document.getElementById("leftSideImage").offsetLeft - pos1) + "px";
    document.getElementById("rightSideImage").style.left = (document.getElementById("rightSideImage").offsetLeft - pos1) + "px";

    if(document.getElementById("leftSideImage").offsetLeft > 0){
    	document.getElementById("leftSideImage").style.left = "0px";
    	document.getElementById("rightSideImage").style.left = "0px";
    }
    if(document.getElementById("leftSideImage").offsetLeft < -1 * (document.getElementById("leftSideImage").width - document.getElementById("leftSideImage").parentElement.getBoundingClientRect().width)){
    	document.getElementById("leftSideImage").style.left = -1 * (document.getElementById("leftSideImage").width - document.getElementById("leftSideImage").parentElement.getBoundingClientRect().width) + "px";
    	document.getElementById("rightSideImage").style.left = -1 * (document.getElementById("leftSideImage").width - document.getElementById("leftSideImage").parentElement.getBoundingClientRect().width) + "px";
    }

    if(e.touches){
    	pos2 = pos4 - e.touches[0].clientY;
    	pos3 = e.touches[0].clientX;
    	pos4 = e.touches[0].clientY;
    }else{
    	pos2 = pos4 - e.clientY;
    	pos3 = e.clientX;
    	pos4 = e.clientY;
    }

    // set the element's new position:
    document.getElementById("leftSideImage").style.top = (document.getElementById("leftSideImage").offsetTop - pos2) + "px";
    document.getElementById("rightSideImage").style.top = (document.getElementById("rightSideImage").offsetTop - pos2) + "px";

    if(document.getElementById("leftSideImage").offsetTop > 0){
    	document.getElementById("leftSideImage").style.top = "0px";
    	document.getElementById("rightSideImage").style.top = "0px";
    }
    if(document.getElementById("leftSideImage").offsetTop < -1 * (document.getElementById("leftSideImage").height - document.getElementById("leftSideImage").parentElement.getBoundingClientRect().height)){
    	document.getElementById("leftSideImage").style.top = -1 * (document.getElementById("leftSideImage").height - document.getElementById("leftSideImage").parentElement.getBoundingClientRect().height) + "px";
    	document.getElementById("rightSideImage").style.top = -1 * (document.getElementById("leftSideImage").height - document.getElementById("leftSideImage").parentElement.getBoundingClientRect().height) + "px";
    }

    document.getElementById('minmapHighlight').style.left = Math.abs(document.getElementById("leftSideImage").offsetLeft * minimapAspectX) + "px";
    document.getElementById('minmapHighlight').style.top = Math.abs(document.getElementById("leftSideImage").offsetTop * minimapAspectY) + "px";
    document.getElementById('minimapHighlightImage').style.left = (document.getElementById("leftSideImage").offsetLeft * minimapAspectX)  + "px";
    document.getElementById('minimapHighlightImage').style.top = (document.getElementById("leftSideImage").offsetTop * minimapAspectY)  + "px";
    var viewportOffset;
    var imageContainer = e.target;

    while ((imageContainer = imageContainer.parentElement) && !imageContainer.classList.contains('imageContainer'));
    if(!imageContainer){
    	trackHighlight.style.visibility = 'hidden';
    	return;
    }
    viewportOffset = imageContainer.getBoundingClientRect();

    var xPos = e.clientX - viewportOffset.left;
    var yPos = e.clientY - viewportOffset.top;
    if(e.touches){
    	xPos = e.touches[0].clientX - viewportOffset.left;
    	yPos = e.touches[0].clientY - viewportOffset.top;
    }
    if(imageContainer.children[0].id == 'leftSideImage'){
    	highight = document.getElementById('rightSideImageCircle');
    }else{
    	highight = document.getElementById('leftSideImageCircle');
    }
    trackHighlight = highight;
    highight.style.visibility = 'visible';
    highight.style.left = xPos;
    highight.style.top = yPos;
}

function closeDragElement(e) {
    // stop moving when mouse button is released:
    e.preventDefault();
    dragging = false;
    document.onmouseup = null;
    document.ontouchend = null;
    document.onmousemove = null;
    document.ontouchmove = null;
    document.getElementById("leftSideImage").ontouchend = processBadAnswer;
    document.getElementById("rightSideImage").ontouchend = processBadAnswer;
    document.getElementById("rightSideImage").focus();
}


imageMapResize();